/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.siemens_enterprise.openstagepush.actions;

import com.opensymphony.xwork2.ActionSupport;
import com.siemens_enterprise.openstagepush.data.DataService;
import java.io.File;
import java.io.IOException;
import java.io.StringWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.Vector;
import javax.xml.transform.Transformer;
import javax.servlet.http.HttpServletRequest;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts2.ServletActionContext;
import org.apache.struts2.convention.annotation.Result;
import org.apache.struts2.convention.annotation.Results;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author atw10t87
 */
@Results({
    @Result(name = "failure", location = "fail.jsp")
})
public class Pushing extends ActionSupport implements ServletRequestAware {

    private static final Log LOGGER = LogFactory.getLog("Pushing");
    private static final String XML_PARAM = "xml";
    private HttpServletRequest httpServletRequest = null;
    private String requestedFile = null;
    private String xmlOutput = null;

    @Override
    public String execute() {

        String retValue = SUCCESS;

        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");

        Map<String, String> ctxHt = new HashMap<String, String>();
        String ctxValues = httpServletRequest.getParameter("action");
        if (ctxValues != null) {
            for (String ctxVal : ctxValues.split(";")) {
                String[] ctxV = ctxVal.split(":");
                if (ctxV != null && ctxV.length == 2) {
                    ctxHt.put(ctxV[0], ctxV[1]);
                }
            }
        }

        String xmlFile = ctxHt.get(XML_PARAM);
        String file = ServletActionContext.getServletContext().getRealPath("/xml/" + xmlFile);
        Element root = getRootElement(file);
        if (root != null) {
            for (Element url : getAllElementsNamed(root, "url")) {
                url.setTextContent(url.getTextContent().replaceAll(
                        "http://137.223.238.174:8080/servlet/IppGenericServlet",
                        httpServletRequest.getRequestURL().toString()));
            }

            for (Element title : getAllElementsNamed(root, "title")) {
                title.setTextContent(title.getTextContent() + " " + sdf.format(new Date()));
            }
            xmlOutput = getXML(root);
        } else {
            retValue = ERROR;
        }

        LOGGER.debug("Output xml is:\n" + xmlOutput);

        return retValue;
    }

    public void setServletRequest(HttpServletRequest httpServletRequest) {
        this.httpServletRequest = httpServletRequest;
    }

    public String getServerAddress() {

        String address = null;
        StringBuilder buffer = new StringBuilder();

        buffer.append(httpServletRequest.getServerName());
        buffer.append(":");
        buffer.append(httpServletRequest.getServerPort());

        address = buffer.toString();

        return address;
    }

    public String getRequestedFile() {
        return requestedFile;
    }

    public String getXmlOutput() {
        return xmlOutput;
    }

    private Element getRootElement(String file) {
        Element eRoot = null;
        try {
            File f = new File(file);
            if (f.exists()) {
                DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

                DocumentBuilder docBuilder = factory.newDocumentBuilder();
                Document doc = docBuilder.parse(f);
                if (doc != null) {
                    eRoot = doc.getDocumentElement();
                }
            }
        } catch (SAXException ex) {
            LOGGER.error("Phones.xml parser's error", ex);
        } catch (IOException ex) {
            LOGGER.error("Phones.xml parser's error", ex);
        } catch (ParserConfigurationException ex) {
            LOGGER.error("Phones.xml parser's error", ex);
        }
        return eRoot;
    }

    private String getXML(Element e) {
        TransformerFactory tFactory = TransformerFactory.newInstance();
        StringWriter writer = new StringWriter();
        try {
            Transformer transformer = tFactory.newTransformer();

            DataService.setupTransformer(transformer);

            DOMSource source = new DOMSource(e);
            StreamResult result = new StreamResult(writer);

            transformer.transform(source, result);
        } catch (TransformerConfigurationException ex) {
            LOGGER.error("Phones.xml parser's error", ex);
        } catch (TransformerException ex) {
            LOGGER.error("Phones.xml parser's error", ex);
        } 

        return writer.toString();
    }

    private static Element[] getAllElementsNamed(Element root, String name) {
        Vector<Element> elems = new Vector<Element>();
        LinkedList<Element> queue = new LinkedList<Element>();
        queue.add(root);

        while (!queue.isEmpty()) {
            Element e = queue.remove();
            NodeList childs = e.getChildNodes();
            for (int i = 0; i < childs.getLength(); i++) {
                Node node = childs.item(i);
                if (node instanceof Element) {
                    queue.add((Element) node);
                }
            }
            if (e.getTagName().compareToIgnoreCase(name) == 0) {
                elems.add(e);
            }
        }

        return elems.toArray(new Element[0]);
    }
}
