/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.siemens_enterprise.openstagepush.actions;

import com.opensymphony.xwork2.ActionSupport;
import com.siemens_enterprise.openstagepush.data.DataService;
import com.siemens_enterprise.openstagepush.data.Phone;
import com.siemens_enterprise.openstagepush.data.RequestType;
import com.siemens_enterprise.openstagepush.data.XmlFile;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Formatter;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts2.ServletActionContext;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.SessionAware;

/**
 *
 * @author atw10t87
 */
public class Pushinvoker extends ActionSupport implements SessionAware, ServletRequestAware {

    private static final Log LOGGER = LogFactory.getLog("PushInvoker");
    private static final String DATA_SESSION_PARAM = "DataService";
    private static final String CURRENT_PHONE_PARAM = "currentPhoneAddress";
    private static final String ADD_COMMAND = "addPhone";
    private static final String DELETE_COMMAND = "deletePhone";

    private static final String PUSH_SERVER_URL = "http://%1$s:8085/server_push.html/ServerPush";

    Map<String, Object> session = null;
    private String currentPhoneAddress = "";
    private DataService dataService = null;
    private HttpServletRequest httpServletRequest = null;
    private String command = null;
    private String action = null;
    private Collection<Phone> phones = new ArrayList<Phone>();

    @Override
    public String execute() {

        String retValue = SUCCESS;

        Object obj = session.get(DATA_SESSION_PARAM);
        
        if (obj != null) {
            dataService = (DataService) obj;
        } else {
            dataService = DataService.getDataService(ServletActionContext.getServletContext());
            session.put(DATA_SESSION_PARAM, dataService);
        }

        extractRequestParams();

        handleCommand();
        return retValue;
    }

    private void extractRequestParams() {
        currentPhoneAddress = httpServletRequest.getParameter(CURRENT_PHONE_PARAM);
        command = httpServletRequest.getParameter("command");

        if (currentPhoneAddress != null && currentPhoneAddress.length() > 0) {
            Formatter fmt = new Formatter();
            action = fmt.format(PUSH_SERVER_URL, currentPhoneAddress).toString();
        }
        LOGGER.debug("command " + command);

    }

    private void handleCommand() {
        if (ADD_COMMAND.equals(command) == true) {
            if (currentPhoneAddress != null && currentPhoneAddress.length() > 0) {
                Phone phone = new Phone(currentPhoneAddress);
                dataService.addPhone(phone);
            }
        } else if (DELETE_COMMAND.equals(command) == true) {
            if (currentPhoneAddress != null && currentPhoneAddress.length() > 0) {
                dataService.deletePhone(currentPhoneAddress);
                currentPhoneAddress = "";
            }
        }
    }

    public Collection<RequestType> getRequestTypes() {
        return RequestType.getTypes();
    }

    public Collection<Phone> getPhones() {
        phones.clear();
        phones.addAll(dataService.getPhones());
        return phones;
    }

    public Collection<XmlFile> getXmlFiles() {
        return dataService.getXmlFiles();
    }

    public void setSession(Map<String, Object> session) {
        this.session = session;
    }

    public String getCurrentPhoneAddress() {
        return currentPhoneAddress;
    }

    public boolean isPhoneSelected() {
        return currentPhoneAddress != null && currentPhoneAddress.length() > 0;
    }

    public void setServletRequest(HttpServletRequest httpServletRequest) {
        this.httpServletRequest = httpServletRequest;
    }

    public String getAction() {

        return action;
    }


    public String getServerAddress() {
        return httpServletRequest.getServerName();
    }

    public int getServerPort() {
        return httpServletRequest.getServerPort();
    }

}
